]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
- __spec_install_post_check_so macro that finds unresolved symbols in shared object...
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# $Revision$, $Date$
2# PLD Linux rpm macros
3
4%epoch 0
5%x8664 x86_64 amd64 ia32e
6
7# kernel compiler
8%kgcc %{__cc}
9%kgcc_package gcc
10
11# compiler version
12%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
13%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
14
15%__rm /bin/rm --interactive=never
16
17# Build system path macros.
18#
19%__autoconf autoconf %{?debug:-Wall}
20%__automake automake -a -c -f --foreign
21%__autopoint autopoint --force
22
23%__gettextize { \
24 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
25 gettextize --copy --force --no-changelog; \
26 else \
27 gettextize --copy --force --no-changelog --intl; \
28 fi; \
29 if [ ! -f po/Makevars ]; then \
30 cp -f po/Makevars{.template,}; \
31 fi; \
32}
33
34%__glib_gettextize glib-gettextize --copy --force
35%__gnome_doc_common gnome-doc-common --copy
36%__gnome_doc_prepare gnome-doc-prepare --copy --force
37%__gtkdocize gtkdocize --copy
38%__intltoolize intltoolize --copy --force
39%__libtoolize libtoolize --copy --force --install
40
41# Path to top of build area.
42%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
43
44# The number of cvs changelog entries kept when building package.
45%_buildchangelogtruncate 20
46
47%dependencytracking %{nil}
48
49# Relations between package names that cause dependency loops
50# with legacy packages that cannot be fixed. Relations are
51# specified as
52# p>q
53# where package p has a Requires: on something that package q Provides:
54#
55# XXX Note: that there cannot be any whitespace within the string "p>q",
56# and that both p and q are package names (i.e. no version/release).
57%_dependency_whiteout %{nil}
58
59%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
60 && RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
61 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$(($RPM_BUILD_NCPUS * 2))")
62
63#-----------------------------------------------------------------
64#
65# (re)definition of %{rpm*flags} with %filterout_* support
66# BuildRequires: awk
67# BuildRequires: rpmbuild(macros) >= 1.315
68#
69# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
70# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
71# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
72# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
73# %rpmldflags = %optldflags - %filterout_ld
74#
75# Regular expressions are supported, but to avoid some character be treated
76# as regular expression it must be escaped twice.
77
78%filter_out \
79 for (i = 1; i in I; i++) { A=0; \
80 for (f in F) { \
81 if (I[i] ~ "^" F[f] "$") A=1; \
82 }; \
83 if (!A) printf(I[i] FS); \
84 }
85
86%rpmcflags %(awk 'BEGIN {
87 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
88 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
89 %{filter_out}
90}')
91
92%rpmcxxflags %(awk 'BEGIN {
93 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
94 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
95 %{filter_out}
96}')
97
98%rpmcppflags %(awk 'BEGIN {
99 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
100 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
101 %{filter_out}
102}')
103
104%rpmldflags %(awk 'BEGIN {
105 split("%{?optldflags}",I);
106 split("%{?filterout_ld}",F)
107 %{filter_out}
108}')
109
110# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
111# but, don't use it, better use gcc as linker
112%ld_rpmldflags %(awk 'BEGIN {
113 split("%{rpmldflags}",F);
114 for (f in F) {
115 s = F[f];
116 if (s ~ /^-Wl,/) {
117 s = substr(s,5);
118 gsub(/,/," ",s);
119 };
120 printf(s FS);
121 };
122}')
123
124#-----------------------------------------------------------------
125%configure2_13 { \
126 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
127 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
128 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
129 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
130 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
131 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
132 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
133 %{?__cc:CC="%{__cc}" ; export CC ; } \
134 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
135 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
136 --host=%{_target_platform} \
137 --prefix=%{_prefix} \
138 --exec-prefix=%{_exec_prefix} \
139 --bindir=%{_bindir} \
140 --sbindir=%{_sbindir} \
141 --sysconfdir=%{_sysconfdir} \
142 --datadir=%{_datadir} \
143 --includedir=%{_includedir} \
144 --libdir=%{_libdir} \
145 --libexecdir=%{_libexecdir} \
146 --localstatedir=%{_localstatedir} \
147 --sharedstatedir=%{_sharedstatedir} \
148 --mandir=%{_mandir} \
149 --infodir=%{_infodir} \
150 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
151 %{dependencytracking} \
152}
153
154%__cmake /usr/bin/cmake
155%cmake { \
156CC="%{__cc}" \
157CXX="%{__cxx}" \
158CFLAGS="%{rpmcflags}" \
159CXXFLAGS="%{rpmcxxflags}" \
160LDFLAGS="%{rpmldflags}" \
161%{__cmake} \
162}
163
164# override __scons to add -j4 in your ~/.rpmmacros for parallel make
165%__scons /usr/bin/scons
166%scons { \
167%{__scons} \
168 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
169 CFLAGS="${CFLAGS:-%rpmcflags}" \
170 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
171 FFLAGS="${FFLAGS:-%rpmcflags}" \
172 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
173 %{?__cc:CC="%{__cc}"} \
174 %{?__cxx:CXX="%{__cxx}"} \
175 libsuffix=%{_lib} \
176 prefix=%{_prefix} \
177}
178
179# waf. see waf.spec
180# override __waf to add -j4 in your ~/.rpmmacros for parallel make
181%__waf /usr/bin/waf
182%waf { \
183CC="%{__cc}" \
184CXX="%{__cxx}" \
185CPP="%{__cpp}" \
186CFLAGS="%{rpmcflags}" \
187CXXFLAGS="%{rpmcxxflags}" \
188%{__waf} \
189}
190
191#----------------------------------------------------------------
192#%configure_cache 0
193%configure_cache_file %{buildroot}.configure.cache
194
195%configure {./configure \
196 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
197 CFLAGS="${CFLAGS:-%rpmcflags}" \
198 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
199 FFLAGS="${FFLAGS:-%rpmcflags}" \
200 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
201 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
202 %{?__cc:CC="%{__cc}"} \
203 %{?__cxx:CXX="%{__cxx}"} \
204 --host=%{_target_platform} \
205 --build=%{_target_platform} \
206 --prefix=%{_prefix} \
207 --exec-prefix=%{_exec_prefix} \
208 --bindir=%{_bindir} \
209 --sbindir=%{_sbindir} \
210 --sysconfdir=%{_sysconfdir} \
211 --datadir=%{_datadir} \
212 --includedir=%{_includedir} \
213 --libdir=%{_libdir} \
214 --libexecdir=%{_libexecdir} \
215 --localstatedir=%{_localstatedir} \
216 --sharedstatedir=%{_sharedstatedir} \
217 --mandir=%{_mandir} \
218 --infodir=%{_infodir} \
219 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
220 %{dependencytracking} \
221 %{?configure_cache:--cache-file=%{configure_cache_file}} \
222}
223
224# overload to insert debuginfo package
225%prep \
226%if 0%{?_enable_debug_packages}\
227%{debug_package}\
228%endif\
229%%prep\
230%{nil}
231
232# Location of autoconf macros
233%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
234
235# Location of omf files
236%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
237
238# Location of pkgconfig files
239%_pkgconfigdir /usr/%{_lib}/pkgconfig
240# noarch pkgconfig files
241%_npkgconfigdir /usr/share/pkgconfig
242
243# Location of desktop files
244%_desktopdir /usr/share/applications
245%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
246
247# Location of pixmaps for applnk/desktop files
248%_pixmapsdir /usr/share/pixmaps
249
250# Location of themable icons for applnk/desktop files
251%_iconsdir /usr/share/icons
252
253# Location of fonts directories
254%_fontsdir /usr/share/fonts
255
256# Location of Gtk and associated libraries documentation
257%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
258
259# Location of KDE documentation
260%_kdedocdir %{_defaultdocdir}/kde/HTML
261
262# unsermake script
263%__unsermake /usr/share/unsermake/unsermake
264
265# Current date
266%date %(LC_ALL="C" date +"%a %b %d %Y")
267
268# Example files, programs, scripts...
269%_examplesdir /usr/src/examples
270
271# Alternative kernel type/version
272%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
273
274# The directory holding Linux kernel sources
275%_kernelsrcdir /usr/src/linux%{_alt_kernel}
276
277# If non-empty "debug" macro defined, add "dbg" suffix to release number
278%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
279
280# Requires name = version-release
281%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
282
283%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
284%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
285%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
286%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
287%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
288%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
289
290# XXX: why epoch 0 is stripped?
291%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
292%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
293
294%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
295
296# kernel version-release handling
297%__kernel_ver %{expand:%%global __kernel_ver %( \\
298 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
299 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
300 echo ${Z:-ERROR}; \\
301)}%__kernel_ver
302
303%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
304%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
305%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
306%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
307
308# `uname -r` to be used in @release field
309%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
310
311# sgml macros
312%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
313%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
314%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
315%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
316%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
317%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
318%docbook_sgmlcat_fix() { for l in \
319'' \
320' -- default decl --' \
321'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
322' -- hacks for opensp --' \
323'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
324'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
325'' \
326; do echo $l; done >> %1 \
327}
328
329# vim - "
330
331# minimum file size needed for compressed documents.
332# just smaller files than this get larger when compressed.
333# some stats:
334# - 0 byte file compressed was 25 bytes .gz
335# - 39 byte file was compressed as 57
336# - with test/test.spec@man 158 byte file was compressed also 158
337%_min_compress_bytes 159
338
339#-----------------------------------------------------------------
340# find and gzip all files in %{_mandir} and %{infodir}
341#
342# Requires: xargs, find
343#
344#%no_install_post_compress_docs 1
345%__spec_install_post_compress_docs { \
346%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
347 for i in /usr/share/man /usr/X11R6/man; do \
348 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
349 echo "Compress man pages: $i"; \
350 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
351 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
352 find $RPM_BUILD_ROOT$i -type l | while read a; do \
353 m=$(readlink $a); \
354 rm -f $a; \
355 echo .so ${m##*/} > $a; \
356 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
357 done; \
358 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
359 fi; \
360 done; \
361 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
362 echo "Compress info pages: %{_infodir}"; \
363 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
364 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
365 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
366 fi; \
367}; __spec_install_post_compress_docs } }
368
369#-----------------------------------------------------------------
370# Strip executable binaries and shared object files
371#
372# Requires: find, awk, strip, cut, xargs
373#
374# Special macros which affect this process:
375#%no_install_post_strip 1 # disable stripping at all
376#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
377#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
378#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
379#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
380#
381%__spec_install_post_strip {%{!?debug: \
382%{!?no_install_post_strip:__spec_install_post_strip() { \
383if [ -d "$RPM_BUILD_ROOT" ]; then \
384 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
385 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
386 if [ "$modulelist" ]; then \
387 modulecount=$(echo "$modulelist" | wc -l); \
388 printf "Stripping %d kernel modules..." $modulecount; \
389 echo "$modulelist" | xargs -l512 chmod u+w; \
390 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
391 echo "DONE"; \
392 fi; \
393 fi; \
394 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
395 if [ -n "$filelist" ]; then \
396 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
397 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
398 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
399 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
400 if [ -n "$elfexelist" ]; then \
401 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
402 chmod u+w $elfexelist; \
403 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
404 echo "DONE"; \
405 fi; \
406 if [ -n "$elfsharedlist" ]; then \
407 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
408 chmod u+w $elfsharedlist; \
409 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
410 echo "DONE"; \
411 fi; \
412 if [ -n "$archiveslist" ]; then \
413 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
414 chmod u+w $archiveslist; \
415 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
416 echo "DONE"; \
417 fi; \
418 fi; \
419 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
420 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
421 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
422 if [ -n "$filelist_all" ]; then \
423 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
424 chmod u+w $filelist_all; \
425 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
426 echo "DONE"; \
427 fi; \
428 if [ -n "$filelist_unneeded" ]; then \
429 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
430 chmod u+w $filelist_unneeded; \
431 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
432 echo "DONE"; \
433 fi; \
434 if [ -n "$filelist_debug" ]; then \
435 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
436 chmod u+w $filelist_debug; \
437 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
438 echo "DONE"; \
439 fi; \
440fi; }; __spec_install_post_strip } } }
441
442#-----------------------------------------------------------------
443# remove all RPATH from executable binaries and shared object files
444#
445# Requires: find, awk, cut, xargs, chrpath, uname
446#
447# Special macros which affect this process
448#%no_install_post_chrpath 1 # disable chrpath at all
449#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
450#
451%__spec_install_post_chrpath {%{!?debug: \
452%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
453if [ -d "$RPM_BUILD_ROOT" ]; then \
454 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
455 if [ -n "$files" ]; then \
456 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
457 fi; \
458 if [ -n "$objs" ]; then \
459 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
460 echo "$objs" | \
461 while read file; do \
462 rpath= ; \
463 chmod u+w "$file"; \
464 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
465 case $dir in \
466 '$ORIGIN' ) \
467 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
468 else rpath="$rpath:$dir" ; fi ; \
469 continue ; \
470 ;; \
471 esac ; \
472 newdir=$(readlink -m "$dir"); \
473 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
474 case $dir in \
475 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
476 echo "remove-rpath: $dir in $file"; \
477 ;; \
478 * ) \
479 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
480 else rpath="$rpath:$dir" ; fi ; \
481 ;; \
482 esac ; \
483 done ; \
484 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
485 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
486 done; \
487 fi; \
488fi; }; __spec_install_post_chrpath } } }
489
490#-----------------------------------------------------------------
491# Find all shared object files with unresolved symbols. Warn
492# and terminate if any found (termination can be turned off by define).
493#%no_install_post_check_so 1
494%__spec_install_post_check_so { \
495 __spec_install_post_check_so() { \
496 fail=0; \
497 printf "Searching for shared objects with unresolved symbols..."; \
498 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so*' -print); do \
499 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "Unresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
500 done ; \
501 echo " DONE"; \
502 %{!?no_install_post_check_so:[ $fail -eq 1 ] && exit 1;} \
503}; __spec_install_post_check_so }}
504
505#-----------------------------------------------------------------
506# Find and gzip all kernel modules
507#
508# Requires: find
509#
510#%no_install_post_compress_modules 1
511%__spec_install_post_compress_modules { \
512%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
513 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
514 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
515 if [ "$q" ]; then \
516 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
517 echo "$q" | xargs -r %{__gzip} -9nf; \
518 echo "DONE"; \
519 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
520 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
521 fi; \
522 fi; \
523}; __spec_install_post_compress_modules } }
524
525# Remove common Perl files we don't package
526%__spec_install_post_perl_clean {\
527%{!?no_install_post_perl_clean: \
528%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
529} }
530
531#-----------------------------------------------------------------
532# Update GConf2 schemas
533#
534# Requires: GConf2
535#
536%gconf_schema_install() \
537 umask 022; \
538 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
539 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
540%{nil}
541
542%gconf_schema_uninstall() \
543if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
544 umask 022; \
545 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
546 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
547fi; \
548%{nil}
549
550#-----------------------------------------------------------------
551# Update desktop MIME database
552# requires: desktop-file-utils
553%update_desktop_database() {{ \
554 umask 022; \
555 /usr/bin/update-desktop-database -q; \
556};} \
557%{nil}
558
559%update_desktop_database_post %update_desktop_database
560
561%update_desktop_database_postun() {{ \
562if [ "$1" = "0" ]; then \
563 %update_desktop_database \
564fi; \
565};} \
566%{nil}
567
568#-----------------------------------------------------------------
569# Update shared MIME info database
570# requires: shared-mime-info
571#
572%update_mime_database() {{ \
573 umask 022; \
574 /usr/bin/update-mime-database %{_datadir}/mime; \
575};} \
576%{nil}
577
578#-----------------------------------------------------------------
579# Update icon cache
580# requires: gtk+
581#
582%update_icon_cache() {{ \
583 umask 022; \
584 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
585};} \
586%{nil}
587
588#-----------------------------------------------------------------
589# Update scrollkeeper database
590# requires: scrollkeeper
591#
592%scrollkeeper_update_post() \
593 /usr/bin/scrollkeeper-update -q; \
594%{nil}
595
596%scrollkeeper_update_postun() \
597if [ "$1" = "0" ]; then \
598 /usr/bin/scrollkeeper-update -q; \
599fi; \
600%{nil}
601
602#-----------------------------------------------------------------
603# post %install sequence:
604# - autodeps exceptions
605# - compress all man and info pages,
606# - strip all ELF executables and ELF shared objects if not %debug.
607# - compress kernel modules if any
608
609###################################################################
610# Requires/Provides automation
611# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
612#
613%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
614%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
615%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
616%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
617%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
618
619#%_noautocompressdoc %{nil}
620#
621%_missing_doc_files_terminate_build 1%{nil}
622%_unpackaged_files_terminate_build %{nil}
623# (X)emacs support
624%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
625%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
626%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
627
628%__php_provides %{nil}
629%__php_requires %{nil}
630%__perl_provides %{nil}
631%__perl_requires %{nil}
632%__mono_provides %{nil}
633%__mono_requires %{nil}
634
635# Perl specific macro definitions.
636%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
637%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
638%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
639%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
640%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
641%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
642
643# Ruby
644%__ruby /usr/bin/ruby
645%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
646%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
647%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
648%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
649%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
650%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
651%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
652%ruby_rdocdir /usr/share/rdoc
653%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
654%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
655%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
656
657%php_pear_dir /usr/share/pear
658%php_data_dir /usr/share/php
659%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
660%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
661%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
662
663# extract php/zend api versions
664%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
665%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
666%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
667%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
668%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
669%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
670%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
671
672# helper macro
673%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
674
675# macros for public use
676# for php extensions (php-pecl)
677%requires_php_extension %{__php_api_requires modules_api php_api_version} \
678%{__php_api_requires zend_module_api} \
679%{__php_api_requires -v %php_major_version debug php_debug} \
680%{__php_api_requires -v %php_major_version thread-safety zend_zts}
681
682# for zend extensions
683%requires_zend_extension %{__php_api_requires zend_module_api} \
684%{__php_api_requires zend_extension_api} \
685%{__php_api_requires -v %php_major_version debug php_debug} \
686%{__php_api_requires -v %php_major_version thread-safety zend_zts}
687
688# for php pdo modules (php-pecl-PDO_*)
689%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
690
691# for using PHP post scripts. for PHP >= 5.0
692%php_webserver_restart \
693[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
694[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
695if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
696 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
697 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
698 %service -q php-fcgi restart \
699 fi \
700fi \
701%{nil}
702
703# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
704%php4_webserver_restart \
705[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
706[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
707if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
708 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
709 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
710 %service -q php-fcgi restart \
711 fi \
712fi \
713%{nil}
714
715# X.org helper macros
716%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
717%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
718
719%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
720%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
721%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
722%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
723%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
724
725%requires_xorg_xserver_extension \
726%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
727%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
728%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
729%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
730%{nil}
731
732%requires_xorg_xserver_xinput \
733%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
734%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
735%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
736%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
737%{nil}
738
739%requires_xorg_xserver_font \
740%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
741%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
742%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
743%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
744%{nil}
745
746%requires_xorg_xserver_videodrv \
747%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
748%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
749%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
750%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
751%{nil}
752
753# Python specific macro definitions.
754# python main version
755%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
756
757# directories
758%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
759%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
760%py_scriptdir %{py_prefix}/share/python%{py_ver}
761%py_incdir /usr/include/python%{py_ver}
762%py_sitedir %{py_libdir}/site-packages
763%py_sitescriptdir %{py_scriptdir}/site-packages
764%py_dyndir %{py_libdir}/lib-dynload
765
766# pure python modules compilation
767%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
768
769%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
770
771# Software written in Python language require Python with main version
772%pyrequires_eq() Requires: %1
773
774# Hardlink binary identical .pyc and .pyo files
775# (idea by glen <at> pld-linux <dot> org)
776%__spec_install_post_py_hardlink {\
777%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
778[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
779 b="${a%.pyc}.pyo"; \
780 if cmp -s "$a" "$b"; then \
781 ln -f "$a" "$b"; \
782 fi; \
783done \
784}; __spec_install_post_py_hardlink } }
785
786# remove python sources, so that check-files won't complain
787# (idea by glen <at> pld-linux <dot> org)
788%py_postclean() \
789for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
790 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
791done \
792%{nil}
793
794# depmod macro
795%depmod() { \
796umask 022; \
797if [ -e /boot/System.map-%1 ]; then \
798 /sbin/depmod -a -F /boot/System.map-%1 %1; \
799else \
800 if [ -e /boot/System.map ]; then \
801 /sbin/depmod -a -F /boot/System.map %1; \
802 else \
803 /sbin/depmod -a %1; \
804 fi \
805fi; \
806}
807
808# XMMS specific macros
809%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
810%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
811%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
812%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
813%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
814%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
815%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
816%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
817%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
818%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
819
820%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
821
822# user/group checking macros
823#
824# Usage:
825# %userremove myuser
826#
827%userremove /usr/lib/rpm/user_group.sh user del
828%groupremove /usr/lib/rpm/user_group.sh group del
829#
830# Usage:
831# if %usertestrm myuser; then
832# /usr/sbin/userdel -r myuser
833# Note:
834# use these macros only if you need to call userdel/groupdel with
835# a non-standard option or take an extra action; otherwise use the
836# %userremove/%groupremove macros
837#
838%usertestrm /usr/lib/rpm/user_group.sh user testrm
839%grouptestrm /usr/lib/rpm/user_group.sh group testrm
840# user group membership management macros
841#
842# Usage:
843# %addusertogroup myuser agroup
844#
845%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
846
847# banner support (useful in {pre,post}{,un} and triggers)
848#
849# Usage:
850# %banner name [-a] [-e] [-n] [-tn] <<EOF
851# the banner text, the banner text
852# the banner text, and following line
853#EOF
854# You can use any form of here-document, <<'EOF' <<-EOT will do.
855# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
856#
857# -a - append to the banner
858# -e - send to stderr instead of stdout
859# -n - no show banner (overrides -t)
860# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
861#
862# Tests:
863# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
864# rpm -E 'date | %banner -e banner' > m; sh -x m
865#
866%banner(aent:) ( \
867RPM_SCRIPTVERBOSITY=5 \
868[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
869if [ -x /usr/bin/banner.sh ]; then \
870 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
871else \
872 CMD="cat%{-e: >&2}" \
873fi \
874eval $CMD %{?2:%2}%{?3: %3}) \
875%{nil}
876
877# useradd/groupadd macros
878# Author: Elan Ruusamäe <glen@pld-linux.org>
879#
880# Usage:
881# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
882# [-g initial_group] [-G group[,...]] login
883#
884# -u uid. REQUIRED
885# -g gid/group. REQUIRED
886# -s defaults to /bin/false
887# -d defaults to /usr/share/empty
888# -c No default
889# -r is accepted but ignored (it's always set)
890# -k skeleton dir. defaults to /usr/share/empty
891# rpm specific flags
892# -P package name. defaults to %{name}
893#
894%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
895%{!-u:%{error:useradd: Required argument -u missing}} \
896%{!-g:%{error:useradd: Required argument -g missing}} \
897%{!?1:%{error:useradd: Required parameter login missing}} \
898if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
899 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
900 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
901 exit 1 \
902 fi \
903else \
904 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
905 /usr/sbin/useradd \\\
906 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
907 -u %{-u*} \\\
908 -r \\\
909 -d %{-d*}%{!-d:/usr/share/empty} \\\
910 -s %{-s*}%{!-s:/bin/false} \\\
911 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
912 -g %{-g*} \\\
913 %{-M} \\\
914 %{-G:-G %{-G*}} \\\
915 %{expand:%{%{#}}} 1>&2 || exit $? \
916 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
917fi;
918
919# Usage:
920# %groupadd [-P package] [-g gid] group
921#
922# -g gid. REQUIRED
923#
924# Sample:
925# %groupadd -P %{name}-base -g %{gid} %{name}
926
927%groupadd(g:P:rfo) \
928%{!-g:%{error:groupadd: Required argument -g missing}} \
929%{!?1:%{error:groupadd: Required parameter group missing}} \
930if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
931 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
932 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
933 exit 1 \
934 fi \
935else \
936 echo "Adding group %{1} GID=%{-g*}." \
937 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
938 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
939fi;
940
941# webapp macros
942# Author: Elan Ruusamäe <glen@pld-linux.org>
943#
944# The config is installed/removed inside trigger, this means that you can any
945# time install apache1/apache/lighttpd package and the configuration file is
946# updated. if you don't need the config for various reason for specific
947# webserver, just remove the symlink from config directory using webapp
948# program. the trigger will not recreate the symlink on upgrades. In other
949# words the config is linked to webserver config directory on first install of
950# PACKAGE or WEBSERVER.
951#
952# Add package's webserver config to webserver webapps dir.
953# Usage:
954# %webapp_register WEBSERVER WEBAPP
955#
956%webapp_register() \
957%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
958if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
959 /usr/sbin/webapp register %1 %2\
960fi\
961# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
962if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
963 %{expand:%service -q %%1 reload}\
964fi\
965%{nil}
966
967# Remove package's config from webserver webapps dir.
968# Usage:
969# %webapp_register [-f] WEBSERVER WEBAPP
970%webapp_unregister(f) \
971%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
972# remove link if either of the packages are gone \
973if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
974 /usr/sbin/webapp unregister %1 %2\
975 %{expand:%service -q %%1 reload}\
976fi \
977%{nil}
978
979# service macro.
980# Author: Elan Ruusamäe <glen@pld-linux.org>
981#
982# calls usual service restart on package %post, but skips the restart if
983# administrator has disabled automatic service restarts in either global
984# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
985#
986# Usage:
987# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
988#
989# -q be silent when service isn't started (for scriplets restaring other package's services)
990# -n NOOP mode, do not actually restart service
991#
992# Requirements:
993# BuildRequires: rpmbuild(macros) >= 1.268
994# Requires: rc-scripts
995# -n option:
996# BuildRequires: rpmbuild(macros) >= 1.450
997%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
998
999
1000# Java macros. based on jpackage macros.java
1001#
1002# Root directory where all Java VMs/SDK/JREs are installed.
1003%_jvmdir %{_libdir}/jvm
1004
1005# Root directory where all Java VMs/SDK/JREs expose their jars
1006%_jvmjardir %{_libdir}/jvm-exports
1007
1008# Root directory for all Java VM/SDK/JRE's private things.
1009%_jvmprivdir %{_libdir}/jvm-private
1010
1011# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1012%_jvmlibdir %{_libdir}/jvm
1013
1014# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1015%_jvmdatadir %{_datadir}/jvm
1016
1017# Root directory for all configurations parts of Java VM/SDK/JRE's
1018%_jvmsysconfdir %{_sysconfdir}/jvm
1019
1020# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1021%_jvmcommonlibdir %{_libdir}/jvm-common
1022
1023# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1024%_jvmcommondatadir %{_datadir}/jvm-common
1025
1026# Root directory for all common configurations parts of Java VM/SDK/JRE's
1027%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1028
1029# Directory where arch-specific (JNI) version-independent jars are installed.
1030%_jnidir %{_libdir}/java
1031
1032%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
1033
1034%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1035%jar %{java_home}/bin/jar
1036%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
1037%javac %{java_home}/bin/javac
1038%javadoc %{java_home}/bin/javadoc
1039
1040%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1041
1042%jpackage_script() \
1043install -d $RPM_BUILD_ROOT%{_bindir}\
1044cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1045#!/bin/sh\
1046#\
1047# %{name} script\
1048# JPackage Project <http://www.jpackage.org/>\
1049\
1050# Source functions library\
1051. %{_javadir}-utils/java-functions\
1052\
1053# Source system prefs\
1054if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1055 . %{_sysconfdir}/java/%{name}.conf\
1056fi\
1057\
1058# Source user prefs\
1059if [ -f $HOME/.%{name}rc ]; then\
1060 . $HOME/.%{name}rc\
1061fi\
1062\
1063# Configuration\
1064MAIN_CLASS=%1\
1065BASE_FLAGS=%2\
1066BASE_OPTIONS=%3\
1067BASE_JARS="%(echo %4 | tr ':' ' ')"\
1068\
1069# Set parameters\
1070set_jvm\
1071set_classpath $BASE_JARS\
1072set_flags $BASE_FLAGS\
1073set_options $BASE_OPTIONS\
1074\
1075# Let's start\
1076run "$@"\
1077EOF
1078
1079# jpackage 1.7
1080# Directory for maven depmaps
1081#
1082%_mavendepmapdir /etc/maven
1083%_mavendepmapfragdir /etc/maven/fragments
1084
1085#
1086# add_to_depmap adds an entry to the depmap. The arguments are:
1087#
1088# %1 the original groupid
1089# %2 the original artifact id
1090# %3 the version
1091# %4 the new groupid
1092# %5 the new artifactid
1093#
1094
1095%add_to_maven_depmap() \
1096install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1097cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1098<dependency>\
1099 <maven>\
1100 <groupId>%1</groupId>\
1101 <artifactId>%2</artifactId>\
1102 <version>%3</version>\
1103 </maven>\
1104 <jpp>\
1105 <groupId>%4</groupId>\
1106 <artifactId>%5</artifactId>\
1107 <version>%3</version>\
1108 </jpp>\
1109</dependency>\
1110\
1111EOF\
1112%{nil}
1113
1114#==============================================================================
1115#
1116# update_maven_depmap updates the main maven depmap
1117#
1118%update_maven_depmap() \
1119echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1120if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1121cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1122fi\
1123echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1124
1125
1126# PEAR install macros
1127# Author: Elan Ruusamäe <glen@pld-linux.org>
1128#
1129# Usage:
1130# %%pear_package_setup ...
1131#
1132# -a # - also unpack SOURCE#. for PEAR bootstrapping
1133# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1134# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1135# -D - pass -D to %setup (so the build dir is not removed)
1136# -c - register channel from local channel.xml file
1137#
1138# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1139# destination hierarchy. you should copy the tree to buildroot after
1140# patching/reorganizing with %%pear_package_install.
1141#
1142# additionally BUILDROOT is stripped from files and files are converted to UNIX
1143# line endings.
1144#
1145# the pear install process output is recorded to install.log, you should put it
1146# to %%doc for later debug or just for information.
1147#
1148# additionally additional-packages.txt is produced if it was detected that the
1149# package has optional dependencies. the file format is suitable of displaying
1150# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1151# automatically added for this file.
1152
1153
1154# records install.log and transforms PEAR names to PLD Linux rpm package names.
1155%__pear_install_log \
1156tee install.log \
1157# make post message of optional packages \
1158grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
1159if [ -s optional-packages.txt ]; then \
1160 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1161else \
1162 rm -f optional-packages.txt \
1163fi \
1164%{nil}
1165
1166# command invoking pear cli
1167%__pear /usr/bin/pear
1168
1169%pear_install(a:n:zD) \
1170%__pear \\\
1171 -c %{builddir}/pearrc \\\
1172 -d doc_dir=/docs \\\
1173 -d temp_dir=/tmp \\\
1174 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1175 -d bin_dir=%{_bindir} \\\
1176 -d data_dir=%{php_pear_dir}/data \\\
1177 -d test_dir=%{php_pear_dir}/tests \\\
1178 install \\\
1179 --packagingroot=%{builddir} \\\
1180 --offline \\\
1181 --nodeps \\\
1182 %{-f:--force} \\\
1183 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1184 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1185%{nil}
1186
1187# The main macro.
1188# using this macro will append optional-packages.txt to the nocompressdoc list
1189# as it's displayed to user after package install. and adding additional gzip
1190# dep is just waste ;)
1191%pear_package_setup(a:n:zDc:) \
1192%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1193%define builddir %{_builddir}/%{srcdir} \
1194%setup -q -c -T %{-D:-D} -n %{srcdir} \
1195%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1196%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1197%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1198%pear_install \
1199%{-z:cd ..} \
1200cat %{-z:$_N/}.install.log | %__pear_install_log \
1201\
1202# undos sources \
1203find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1204%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1205%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1206%{nil}
1207
1208# Copies exctracted PEAR package structure and PEAR registry to buildroot.
1209# Author: Elan Ruusamäe <glen@pld-linux.org>
1210%pear_package_install() \
1211cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1212find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1213# help the developer out a little: \
1214if [ -f _noautoreq ]; then \
1215 echo "AutoReqdep detected:" \
1216 echo "_noautoreq $(cat _noautoreq)" \
1217fi \
1218%{nil}
1219
1220
1221# Register OpenLDAP schema.
1222# Author: Elan Ruusamäe <glen@pld-linux.org>
1223#
1224# Usage:
1225# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1226#
1227# -d specify dependant schemas, separated by comma
1228#
1229%openldap_schema_register(d:) \
1230for schema in %*; do \
1231 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1232 %{__sed} -i -e " \
1233 /^include.*local.schema/{ \
1234 iinclude\\t $schema\
1235 } \
1236 " /etc/openldap/slapd.conf \
1237 fi \
1238done \
1239# enable dependant schemas \
1240if [ "%{-d*}" ]; then \
1241 %{__sed} -i -e ' \
1242 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1243 s/^#// \
1244 }' /etc/openldap/slapd.conf \
1245fi \
1246%{nil}
1247
1248# Unregister OpenLDAP schema.
1249# Author: Elan Ruusamäe <glen@pld-linux.org>
1250#
1251# Usage:
1252# %%openldap_schema_unregister %{schemadir}/horde.schema
1253#
1254%openldap_schema_unregister() \
1255for schema in %*; do \
1256 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1257 %{__sed} -i -e " \
1258 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1259 # for symmetry it would be nice if we disable enabled schemas in post, \
1260 # but we really can not do that, it would break something else. \
1261 " /etc/openldap/slapd.conf \
1262 fi \
1263done \
1264%{nil}
1265
1266%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1267
1268
1269# Build modules for kernels 2.6
1270# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1271#
1272# Usage:
1273# %build_kernel_modules -m <modules> -C <directory>
1274#
1275# remember that proper Makefile is still required
1276# Options:
1277# -m <modules> (required) -- comma-separated list of modules to save,
1278# without .ko extension, may be placed in subdirectory
1279# -C <directory> -- change to <directory> before doing anything
1280# -p <arg>, -P <arg> -- arguments passeed to make scripts
1281# -c -- do not execute make clean
1282# <additional arguments> -- all additional arguments will be passed to
1283# make modules
1284#
1285# Additional patching supported via here document. Try:
1286# %build_kernel_modules -m module <<'EOF'
1287# your patch script here
1288# EOF
1289# Don't use it unless patching depends on config options.
1290
1291# Developer note: don't touch it unless you know how to handle '\'.
1292# - \ in script expands to nothing
1293# - \\\ in script expands to \
1294# - \\\ inside definition expands to nothing
1295# - \\\\\\\ inside definition expands to \
1296# - in last line \ has to touch arguments so arguments passing
1297# in new lines (using \) will be supported
1298
1299%build_kernel_modules(p:P:m:C:c) \
1300%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1301 \
1302%define Opts \\\\\\\
1303%if "%{_target_base_arch}" != "%{_arch}" \\\
1304 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
1305 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
1306 %else \\\
1307 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1308 %endif \\\
1309%else \\\
1310 CC="%{kgcc}" \\\
1311%endif \
1312%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1313 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1314 \
1315%{?-C:cd %{-C*}} \
1316compile() { \
1317 local L="<" PATCH_SH; \
1318 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1319 set -e -x \
1320 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1321 \
1322for cfg in ${cfgs:-dist}; do \
1323 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1324 \
1325 rm -rf o \
1326 install -d o/include/linux o/arch/powerpc/lib \
1327 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1328 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1329 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1330 \
1331 set +x \
1332 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1333 set -x \
1334 \
1335 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
1336 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1337 %{-p*} %{-P*} \\\
1338 %{MakeOpts} \
1339 %else \
1340 install -d o/include/config \
1341 touch o/include/config/MARKER \
1342 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1343 %endif \
1344 \
1345 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1346 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
1347 ${1+"$@"} \\\
1348 M=$PWD %{MakeOpts}} \
1349 \
1350 %{__make} -C %{_kernelsrcdir} modules \\\
1351 ${1+"$@"} \\\
1352 M=$PWD %{MakeOpts} \
1353 \
1354 for MODULE in {%{-m*},}; do \
1355 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1356 done \
1357done \
1358%{?-C:cd -} \
1359} \
1360compile %{*}\
1361%{nil}
1362
1363
1364# Install kernel modules built by %build_kernel_modules
1365# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1366#
1367# Usage:
1368# %install_kernel_modules -m <modules> -d <directory>
1369#
1370# Options:
1371# -m <modules> (required) -- comma-separated list of modules to install,
1372# without .ko extension, may be placed in subdirectory
1373# -d <directory> (required) -- in what subdirectory modules should be
1374# installed (eg. misc, kernel/drivers/net)
1375# -s <suffix> -- suffix to use when installing modules, useful when module
1376# with same name exists in kernel already
1377# -n <file> -- name of modprobe config file to use (without .conf extension)
1378# for defining aliases, only useful with -s
1379
1380%install_kernel_modules(m:d:s:n:) \
1381%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1382%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1383%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1384 \
1385%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1386%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1387 \
1388local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1389 \
1390for MODULE in {%{-m*},}; do \
1391 [ -n "${MODULE}" ] || continue \
1392 for cfg in ${cfgs:-dist}; do \
1393 [ "$cfg" = smp ] && suf=smp || suf= \
1394 MNAME=${MODULE##*/} \
1395 install -D ${MODULE}-$cfg.ko \\\
1396 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1397 %{?-s:install -d %{ModprobeD}$suf \
1398 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1399 >> %{ModprobeD}$suf/%{-n*}.conf} \
1400 done \
1401done \
1402%{nil}
1403
1404# patchset macros
1405# Author: Elan Ruusamäe <glen@pld-linux.org>
1406#
1407# Usage:
1408# %patchset_source -f <seq(1) format> <start> [<end>]
1409# %patchset_patch <start> [<end>]
1410#
1411# If <end> is omited, it is assumed to be <start>.
1412#
1413# For example in preamble:
1414# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1415# and in %prep:
1416# %patchset_patch 33 44
1417
1418# generate SourceX urls from range START STOP
1419# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1420# The sources start from 10000
1421%patchset_source(f:b:) %(
1422 base=%{-b*}%{!-b*:10000};
1423 start=$(expr $base + %1);
1424 end=$(expr $base + %{?2}%{!?2:%{1}});
1425 # we need to call seq twice as it doesn't allow two formats
1426 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1427 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1428 paste %{tmpdir}/__ps{1,2};
1429 rm -f %{tmpdir}/__ps{1,2};
1430) \
1431%{nil}
1432
1433# apply sources from %patchset_source
1434# -p specify -pX for %patch line
1435# -b base offset: defaults to 10000
1436%patchset_patch(f:p:b:) %(
1437 base=%{-b*}%{!-b*:10000};
1438 start=$(expr $base + %1);
1439 end=$(expr $base + %{?2}%{!?2:%{1}});
1440 echo ": patchset_patch %1%{?2: to %2}";
1441 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1442) \
1443%{nil}
1444
1445# browser plugins v2
1446# Author: Elan Ruusamäe <glen@pld-linux.org>
1447#
1448# Usage:
1449# %browser_plugins_add_browser <name> -p <plugindir>
1450#
1451# <name> (required) -- name of the browser. usually %{name}.
1452# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1453# -b -- default blacklists
1454# -a <arch> override arch
1455#
1456# Example:
1457# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1458
1459%_browserpluginsconfdir /etc/browser-plugins
1460%_browserpluginsdir %{_libdir}/browser-plugins
1461%update_browser_plugins /usr/sbin/update-browser-plugins || :
1462
1463%browser_plugins_add_browser(p:b:a:) \
1464 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1465 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1466 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1467 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1468 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1469 %{-b:cat >> $blacklist_file %{-b*}} \
1470%{nil}
1471
1472# Helper for LUA.
1473# split string separated by space into quoted list
1474#
1475# Author: Elan Ruusamäe <glen@pld-linux.org>
1476#
1477# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1478%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1479
1480# adjust /etc/shells by adding and removing shells from there
1481# Author: Elan Ruusamäe <glen@pld-linux.org>
1482#
1483# Usage:
1484# %post -p <lua>
1485# %lua_add_etc_shells /bin/sh /bin/pdksh
1486#
1487# %preun -p <lua>
1488# if arg[2] == 0 then
1489# %lua_remove_etc_shells /bin/bash /bin/rbash
1490# end
1491#
1492# Requirements:
1493# BuildRequires: rpmbuild(macros) >= 1.462
1494#
1495
1496%lua_add_etc_shells() \
1497t = {}\
1498f = io.open("/etc/shells", "r")\
1499if f then\
1500 for l in f:lines() do t[l]=l; end\
1501 f:close()\
1502end\
1503for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1504 if not t[s] then\
1505 print("Adding "..s.." to /etc/shells")\
1506 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1507 end\
1508end\
1509%{nil}
1510
1511%lua_remove_etc_shells() \
1512t = {}\
1513f = io.open("/etc/shells", "r")\
1514if f then\
1515 for l in f:lines() do t[l]=l; end\
1516 f:close()\
1517end\
1518for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1519 print("Removing "..l.." from /etc/shells")\
1520 t[l] = nil\
1521end\
1522s=""\
1523for _, l in pairs(t) do\
1524 s=s..l.."\\n"\
1525end\
1526io.open("/etc/shells", "w"):write(s)\
1527%{nil}
1528
1529# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1530#
1531# Author: Elan Ruusamäe <glen@pld-linux.org>
1532#
1533# Usage:
1534# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1535# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1536#
1537# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1538#
1539# Requirements:
1540# BuildRequires: rpmbuild(macros) >= 1.429
1541#
1542%add_etc_shells(p) %{-p:<lua>}\
1543%{expand:%%lua_add_etc_shells %*}\
1544%{nil}
1545
1546%remove_etc_shells(p) %{-p:<lua>}\
1547%{-p:if arg[2] == 0 then}\
1548%{expand:%%lua_remove_etc_shells %*}\
1549%{-p:end} \
1550%{nil}
1551
1552# Check syntax for Python files
1553#
1554# Author: Elan Ruusamäe <glen@pld-linux.org>
1555# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1556#
1557# Usage:
1558# %py_lint src
1559#
1560# Requirements:
1561# BuildRequires: python
1562# BuildRequires: rpmbuild(macros) >= 1.469
1563
1564%py_lint() \
1565__py_lint() { \
1566find "$@" -type f -name '*.py' | python -c ' \
1567import sys \
1568import compiler \
1569\
1570err = 0\
1571for f in sys.stdin: \
1572 fd = open(f.strip()) \
1573 c = fd.read() \
1574 fd.close() \
1575 try: \
1576 compiler.parse(c) \
1577 except SyntaxError, e: \
1578 print "py_lint: %s: %s" % (f.strip(), e) \
1579 err = err + 1\
1580\
1581if err: \
1582 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1583 sys.exit(1) \
1584else: \
1585 print >> sys.stderr, "py_lint: Found no syntax errors." \
1586' \
1587}; __py_lint %* \
1588%{nil}
1589
1590# vim:ts=4 sw=4 noet syn=spec
This page took 0.038439 seconds and 4 git commands to generate.